unit sz_k01;

INTERFACE

uses
  crt, graph;

type
  string50 = string[50];


const
{  path : string50 = 'c:\langs\tp';}
  path : string50 = 'c:\laci\pascal\bgi';
  m_b = ['n', 'N', 'c', 'C', 'g', 'G', 'l', 'L', 'p', 'P', 's', 'S', 'k', 'K'];
  szamjegyek = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9'];
  n = 5;
  



type
  keret = record
            x1 : integer;
            x2 : integer;
            x3 : integer;
            x4 : integer;
            x5 : integer;
            y1 : integer;
            y2 : integer;
            y3 : integer;
            y4 : integer;
            y5 : integer;
          end;
  pont = record
           x : integer;
           y : integer;
         end;
  adat = array[1..n] of integer;
  fnev = string[12];



Procedure GrafikusRa(p : string50; var mX, mY : integer);
Procedure KeretGeneral(mX, mY : integer; c : string; var kk : keret; aa : adat);
Procedure SzovegesRe;
Procedure keretez(yy, n : integer);
Procedure KeretCserel(y : integer; var aa : adat);
Procedure Ugraszt(c1, c2 : char; var i : integer);
Procedure MenuMozgat(var ch1 : char; y : integer; var aa : adat);
Procedure FajlKiIr(fn : fnev);
Procedure Folytat(mX, mY : integer; c : string50; kk : keret; var aa : adat);


IMPLEMENTATION

Procedure GrafikusRa(p : string50; var mX, mY : integer);
  var
    vege : boolean;
    gd, gm : integer;
    ch : char;
    siker : boolean;

  procedure detektal(p : string50; var s : boolean);
    begin
      DetectGraph(gd, gm);
      InitGraph(gd, gm, p);
      s := (GraphResult = grOK);
    end;

  begin
    detektal(path, siker);
    if (siker)
      then
        begin
          vege := true;
          mX := GetMaxX;
          mY := GetMaxY;
        end
      else
        begin
          vege := false;
          repeat
            clrscr;
            writeln('Hibs a BGI fjlok tvonala!');
            repeat
              writeln;
              write('Prbljuk jbl? (i/n) : i');
              ch := readkey;
            until ((ch = #13) or (ch = 'n'));
            if (ch = #13)
              then
                begin
                  writeln;
                  write('A BGI fjlok tvonala: ');
                  readln(p);
                  detektal(path, siker);
                  if (siker)
                    then
                      begin
                        vege := true;
                        mX := GetMaxX;
                        mY := GetMaxY;
                      end;
                end
              else
                begin
                  vege := true;
                end;
          until (vege);
        end;
  end;


Procedure KeretGeneral(mX, mY : integer; c : string; var kk : keret; aa : adat);
  var
    x, y : integer;
    sz : string[5];

  begin
    kk.x1 := 0;
    kk.x2 := mX - 220;
    kk.x3 := mX;
    kk.x4 := round(0.6 * mX);
    kk.x5 := round(1 * mx);
    kk.y1 := 0;
    kk.y2 := 20;
    kk.y4 := mY - 20;
    kk.y3 := (kk.y2 + (round((kk.y4 - kk.y2) * 0.5)));
    kk.y5 := mY;

    Rectangle(kk.x1, kk.y1, kk.x2, kk.y2);
    SetTextJustify(CenterText, CenterText);
    OutTextXY((round((kk.x1 + kk.x2) / 2)), (round((kk.y1 + kk.y2) / 2)), c);

    Rectangle(kk.x2, kk.y1, kk.x3, kk.y2);
    SetTextJustify(LeftText, CenterText);
    OutTextXY((kk.x2 + 60), (round((kk.y1 + kk.y2) / 2)), '. szimulcis lps');
    str(aa[3], sz);
    SetTextJustify(RightText, CenterText);
    OutTextXY(480, 10, sz);

{A szimulcis tr helye}
    Rectangle(kk.x1, kk.y2, kk.x4, kk.y3);
    SetTextJustify(CenterText, CenterText);


{A grafikon helye}
    Rectangle(kk.x1, kk.y3, kk.x5, kk.y4);


    Rectangle(kk.x4, kk.y2, kk.x3, kk.y3);
    OutTextXY((round((kk.x4 + kk.x3) / 2)), (round((kk.y2 + kk.y3) / 2)), 'A paramterek helye');

    Rectangle(kk.x1, kk.y4, kk.x3, kk.y5);
    OutTextXY((round((kk.x1 + kk.x3) / 2)), (round((kk.y4 + kk.y5) / 2)),
              'Norml  Csendes  Grafikon be/ki  Lpsenknt  Paramterek  Segtsg  Kilps');

    y := kk.y5 - 5;
    line(17, y, 23, y);
    line(81, y, 87, y);
    line(153, y, 159, y);
    line(281, y, 287, y);
    line(385, y, 391, y);
    line(489, y, 494, y);
    line(569, y, 575, y);
  end;



Procedure SzovegesRe;
  begin
    CloseGraph;
  end;

Procedure keretez(yy, n : integer);


  procedure csinal(tol, ig : integer);
    var
      i, j : integer;

    begin
      for i := (yy - 20) to yy do
        begin
          for j := tol to ig do
            begin
              PutPixel(j, i, (GetPixel(j, i) xor 15));
            end;
        end;
    end;

  begin
    case (n) of
      1 : begin
            csinal(8, 71);
          end;
      2 : begin
            csinal(72, 144);
          end;
      3 : begin
            csinal(145, 271);
          end;
      4 : begin
            csinal(272, 375);
          end;
      5 : begin
            csinal(376, 479);
          end;
      6 : begin
            csinal(480, 560);
          end;
      7 : begin
            csinal(561, 632);
          end;
    end;
  end;



Procedure KeretCserel(y : integer; var aa : adat);
  begin
    keretez(y, aa[2]);
    keretez(y, aa[1]);
    aa[2] := aa[1];
  end;


Procedure Ugraszt(c1, c2 : char; var i : integer);
  begin
    case (c1) of
      'n' : begin
              i := 1;
            end;
      'N' : begin
              i := 1;
            end;
      'c' : begin
              i := 2;
            end;
      'C' : begin
              i := 2;
            end;
      'g' : begin
              i := 3;
            end;
      'G' : begin
              i := 3;
            end;
      'l' : begin
              i := 4;
            end;
      'L' : begin
              i := 4;
            end;
      'p' : begin
              i := 5;
            end;
      'P' : begin
              i := 5;
            end;
      's' : begin
              i := 6;
            end;
      'S' : begin
              i := 6;
            end;
      'k' : begin
              i := 7;
            end;
      'K' : begin
              i := 7;
            end;
      #0 : begin
             case (c2) of
               #75 : begin
                       dec(i);
                       if (i = 0)
                         then
                           begin
                             i := 7;
                           end;
                     end;
               #77 : begin
                       inc(i);
                       if (i = 8)
                         then
                           begin
                             i := 1;
                           end;
                     end;
             end;
           end;
    end;
  end;


Procedure MenuMozgat(var ch1 : char; y : integer; var aa : adat);
  var
    ch2 : char;


  begin
    repeat
      repeat
        ch1 := readkey;
        if (ch1 = #0)
          then
            begin
              ch2 := readkey;
            end;
      until((ch1 = #13) or (ch1 in m_b) or ((ch1 = #0) and ((ch2 = #75) or (ch2 = #77))));
      Ugraszt(ch1, ch2, aa[1]);
      KeretCserel(y, aa);
    until ((ch1 = #13) or (ch1 in m_b));
  end;

Procedure FajlKiIr(fn : fnev);
  var
    f : text;
    i : integer;
    szov : string[80];
    ch : char;
    tovabb : boolean;

  begin
    tovabb := false;
    assign(f, fn);
    {$I-}
    reset(f);
    if (ioResult = 0)
      then
        begin
          tovabb := true;
        end;
    {$I+}
    if (tovabb)
      then
        begin
          ClearDevice;
          SetTextJustify(CenterText, CenterText);
          i := 1;
          while (i <= 8) do
            begin
              readln(f, szov);
              OutTextXY(320, (10 + (10 * i)), szov);
              inc(i);
            end;
          SetTextJustify(LeftText, CenterText);
          while (not(eof(f))) do
            begin
              readln(f, szov);
              OutTextXY(10, (10 + (10 * i)), szov);
              inc(i);
            end;
          close(f);
          repeat
            ch := ReadKey;
          until (ch = #27);
          ClearDevice;
        end;
  end;




Procedure Folytat(mX, mY : integer; c : string50; kk : keret; var aa : adat);
  begin
    KeretGeneral(mX, mY, c, kk, aa);
    keretez(mY, aa[1]);
    aa[2] := aa[1];
  end;


BEGIN

END.