program gazmodell; {Szukics Sarolta, Varga Zsombor}
{$F+}
uses crt,graph;
const path  = 'c:\langs\tp\bgi';
      p1x=550;
      p1y=30;
      p2x=500;
      p2y=280;
      p3x=500;
      p3y=450;
      cim='Elemi diffzis gzmodell';
      hatterszin=2;
      betuszin=15;
      maxmenupontdb=7;
      elemsz=10;
      maxmax=200;

type moltip=record doboz:integer;
                   helyx:integer;
                   helyy:integer;
            end;
     tombtip1=array[0..maxmax] of integer;
     tombtip2=array[1..maxmax] of integer;

var max,n,sorszam,elsodoboz,A,fele,vhelyx,vhelyy:integer;
    sx,sy:word;
    szl,aktmenupont,egysegx,{i,}aktmag:integer;
    ch,c,k,varo,p,l:char;
    ymax:longint;
    kilep,kilepo:boolean;
    f:text;
    sor:string;
    S:tombtip1;
    D:tombtip2;
    M:array[1..maxmax] of moltip;
    egysegy:real;
    kapcsolo:record szt,g,pa,lep:boolean;
                    end;

Procedure Szovegesre;
  begin
    CloseGraph;         {lezarja a grafikus uzemmodot}
    RestoreCrtMode;     {Visszaallitja az InitGraph meghivasa elotti
                        kepernyokezelesi modot}
  end;

Procedure Grafikusra;
    Var
       gd,gm : integer;
  Begin
    DetectGraph(gd,gm);    {detektalja a grafikus eszkozt}
    InitGraph(gd,gm,path); {inicializalja a grafikus rendszert}
  End;

Procedure init;   {inicializalja a kezdoertekeket}
begin
 sx:=getmaxx;
 sy:=getmaxy;
 szl:=0;
 setcolor(betuszin);
 setbkcolor(hatterszin);
end;

procedure elolrol;      forward;

procedure kezdolap;
var maxstr:string;
    ok:integer;
begin
     clrscr;
     randomize;
     writeln;
     repeat
           write('sszesen hny molekula legyen? (max.',maxmax,'): ');
           readln(maxstr);
           val(maxstr,max,ok);
           if ok<>0 then writeln('Nem egsz szmot, vagy tl nagy szmot rtl!')
                    else if max>maxmax then begin
                                                    writeln('Tl nagy szmot rtl!');
                                                    ok:=1;
                                               end
                                          else if max<1 then begin
                                                                  writeln('Tl kicsi szmot rtl!');
                                                                  ok:=1;
                                                             end;
     until ok=0;
     repeat
           write('Az els dobozban hny molekula legyen? (max.',max,'): ');
           readln(maxstr);
           val(maxstr,elsodoboz,ok);
           if ok<>0 then writeln('Nem egsz szmot, vagy tl nagy szmot rtl!')
                    else if elsodoboz>max then begin
                                                    writeln('Tl nagy szmot rtl!');
                                                    ok:=1;
                                               end
                                          else if elsodoboz<0 then begin
                                                                  writeln('Tl kicsi szmot rtl!');
                                                                  ok:=1;
                                                             end;
     until ok=0;
end;

procedure keretek;
begin
     rectangle(0,0,p1x,p1y);    {szim.neve kerete}
     rectangle(p1x,0,sx,p1y);   {szim.lepes kerete}
     rectangle(0,p1y,p2x,p2y);  {szim.ter kerete}
     rectangle(0,p2y,p3x,p3y);  {grafikon kerete}
     rectangle(p2x,p1y,sx,p3y); {parameterter kerete}
     rectangle(0,p3y,sx,sy);    {menu kerete}
end;

procedure cimkiiras;
begin
     outtextxy(10,p1y-15,cim);
end;

procedure diagram; forward;

{----------------paramterek kezelse------------------}
procedure paramkiir;
var maxstr,Astr:string;
begin
     outtextxy(p2x+10,p1y+10,'Molekulk szma: ');
     str(max,maxstr);
     outtextxy(p2x+10,p1y+20,maxstr);
     outtextxy(p2x+10,p1y+40,'Az elso dobozban: ');
     setfillstyle(1,hatterszin);
     bar(p2x+10,p1y+50,p2x+60,p1y+60);
     str(A,Astr);
     outtextxy(p2x+10,p1y+50,Astr);

end;

procedure parammodosit;
var maxstr:string;
    i:integer;
begin
     setcolor(red);
     outtextxy(p2x+10,p1y+10,'Molekulk szma: ');
     str(max,maxstr);
     outtextxy(p2x+10,p1y+20,maxstr);
     repeat
           p:=readkey;
           case p of
                #72: begin
                          inc(max);
                          if max>maxmax then max:=1;
                          if max<A then max:=A;
                          str(max,maxstr);
                          setfillstyle(1,hatterszin);
                          bar(p2x+10,p1y+20,p2x+100,p1y+30);
                          outtextxy(p2x+10,p1y+20,maxstr);
                     end;
                #80: begin
                          dec(max);
                          if max<A then max:=A;
                          str(max,maxstr);
                          setfillstyle(1,hatterszin);
                          bar(p2x+10,p1y+20,p2x+100,p1y+30);
                          outtextxy(p2x+10,p1y+20,maxstr);
                     end;
                #73: begin
                          max:=max+10;
                          if max>maxmax then max:=max-maxmax;
                          if max<A then max:=A;
                          str(max,maxstr);
                          setfillstyle(1,hatterszin);
                          bar(p2x+10,p1y+20,p2x+100,p1y+30);
                          outtextxy(p2x+10,p1y+20,maxstr);
                     end;
                #81: begin
                          max:=max-10;
                          if max<0 then max:=max+maxmax;
                          if max<A then max:=A;
                          str(max,maxstr);
                          setfillstyle(1,hatterszin);
                          bar(p2x+10,p1y+20,p2x+100,p1y+30);
                          outtextxy(p2x+10,p1y+20,maxstr);
                     end;
            end;
     until p=#13;
     A:=0;
     for i:=1 to max do
         begin
              if D[i]=1 then inc(A);
         end;
     setfillstyle(1,hatterszin);
     setcolor(betuszin);
     bar(1,p2y+1,p3x-1,p3y-1);
     bar(1,p1y+1,p2x-1,p2y-1);
end;
{----------------paramterek kezelsnek vge----------}

procedure szimter;
var j:integer;
begin
     setfillstyle(1,8);
     bar(11,p1y+11,fele-1,p2y-11);
     bar(fele+1,p1y+11,p2x-11,p2y-11);
     setfillstyle(1,hatterszin);
     rectangle(10,p1y+10,p2x-10,p2y-10);
     fele:=p2x div 2;
     line(fele,p1y+10,fele,p2y-10);
     for j:=1 to max do
     begin
          putpixel(M[j].helyx,M[j].helyy,white);
     end;
end;

{-------------a szimulacio lelke---------------------------}
procedure veletlenhely1;
begin
     vhelyx:=random(fele-12)+11;
     vhelyy:=random(p2y-p1y-21)+p1y+11;
end;

procedure veletlenhely2;
begin
     vhelyx:=random(fele-12)+fele+1;
     vhelyy:=random(p2y-p1y-21)+p1y+11;
end;


procedure szimfugg(max:integer);
var i,j:integer;
    oke:boolean;
begin
     i:=random(max)+1;
     if D[i]=1 then begin
                        D[i]:=2;
                        A:=A-1;
                        S[A]:=S[A]+1;
                        {putpixel(M[i].helyx,M[i].helyy,hatterszin);}
                        repeat
                              veletlenhely2;
                              j:=1;
                              oke:=false;
                              while (j<max) and (not oke) do
                              begin
                                   oke:=((vhelyx=M[j].helyx) and (vhelyy=M[j].helyy));
                                   inc(j);
                              end;
                        until not oke;
                        M[i].helyx:=vhelyx;
                        M[i].helyy:=vhelyy;
                        M[i].doboz:=2;
                   end
              else begin
                        D[i]:=1;
                        A:=A+1;
                        S[A]:=S[A]+1;
{                        putpixel(M[i].helyx,M[i].helyy,hatterszin);  }
                        repeat
                              veletlenhely1;
                              j:=1;
                              oke:=false;
                              while (j<max) and (not oke) do
                              begin
                                   oke:=((vhelyx=M[j].helyx) and (vhelyy=M[j].helyy));
                                   inc(j);
                              end;
                        until not oke;
                        M[i].helyx:=vhelyx;
                        M[i].helyy:=vhelyy;
                        M[i].doboz:=1;
                   end;
end;

procedure szimlepes(szt:boolean;g:boolean;pa:boolean;lep:boolean);
var szlstr:string;
begin
     inc(szl);
     setfillstyle(1,hatterszin);
     bar(p1x+1,1,sx-1,p1y-1);
     setcolor(betuszin);
     str(szl,szlstr);
     outtextxy(p1x+10,p1y-15,szlstr);
     szimfugg(max);
     if szt then szimter;
     if g then diagram;
     if pa then paramkiir;
{     if lep then begin
                      {????????????????????????????????????????}
{                 end;}

end;

{--------------a szimulacio lelkenek vege---------------------------}

{----------------grafikonrajzolas---------------------------}

{function maxker(S:tombtip):integer;
var i,maxertek:integer;
begin
     maxertek:=S[1];
     for i:=2 to max do
     begin
          if maxertek<S[i] then maxertek:=S[i];
     end;
     maxker:=maxertek;
end;}

procedure grafikontengelyek;
var istr:string;
    i:integer;
begin
     line(20,p3y-20,20,p2y+5);           {y tengely}
     outtextxy(25,p2y+5,'log S[X]');
     outtextxy(50,p2y+10,'2');
     line(20,p3y-20,p2x-5,p3y-20);       {x tengely}
     outtextxy(p2x-10,p3y-15,'X');
     line(17,p2y+15,20,p2y+5);
     line(23,p2y+15,20,p2y+5);
     line(p2x-15,p3y-23,p2x-5,p3y-20);
     line(p2x-15,p3y-17,p2x-5,p3y-20);
     egysegx:=trunc((p2x-5-20)/max);
     egysegy:=10/ln(2);
     for i:=1 to max do              {x tengely felosztasa}
     begin
           if (i mod 20 = 0) then begin
                                     line(20+(i*egysegx),p3y-16,20+(i*egysegx),p3y-24);
                                     str(i,istr);
                                     outtextxy(14+(i*egysegx),p3y-12,istr);
                                end;
     end;
     for i:=1 to 13 do                   {y tengely felosztsa}
     begin
          line(16,p3y-20+(-i*10),24,p3y-20+(-i*10));
          str(i,istr);
          outtextxy(2,p3y-23+(-i*10),istr);
     end;
end;

procedure diagram;
var ystr:string;
    sv,sv2:real;
    i:integer;
begin
     grafikontengelyek;
     setfillstyle(1,hatterszin-1);
     for i:=1 to max do
     begin
          if S[i]>0 then begin
                         sv:=ln(S[i]);
                         aktmag:=round(egysegy*sv);
                         bar(20+((i-1)*egysegx),p3y-20-aktmag,20+(i*egysegx),p3y-20);
                         rectangle(20+((i-1)*egysegx),p3y-20-aktmag,20+(i*egysegx),p3y-20);
{                         bar(p2x+5,p2y,sx-10,p2y+10);
                         str(S[50],ystr);
                         outtextxy(p2x+5,p2y,ystr);}
                         end;
     end;
{     if maxker(S)>ymax then begin
                                 ymax:=ymax*2;
                                 setfillstyle(1,hatterszin);
                                 bar(11,p2y+1,p3x-1,p3y-1);
                                 bar(p2x+5,p2y,sx-10,p2y+10);
                                 str(ymax,ystr);
                                 outtextxy(p2x+5,p2y,ystr);
                            end;}
end;

{---------------grafikonrajzolas vege-------------------------}

{-------------menuzes-----------------------}
type tmenu=record
                 sorsz:integer;
                 szoveg:string[20];
                 vegrehajt:procedure;
                 bfx:integer;
                 bfy:integer;
                 jax:integer;
                 jay:integer;
            end;
var msorsz:integer;
    menutomb:array [1..maxmenupontdb] of tmenu;

procedure elj;
begin
end;

procedure kilepes; forward;

procedure normal;
begin
     kapcsolo.szt:=true;
     kapcsolo.g:=true;
     kapcsolo.pa:=true;
end;

procedure csendes;
begin
     kapcsolo.szt:=false;
     kapcsolo.g:=false;
     kapcsolo.pa:=true;
end;

procedure graf;
begin
     kapcsolo.g:=not kapcsolo.g;
end;

procedure lepesenkent;
begin
     kapcsolo.lep:=not kapcsolo.lep;
end;

procedure segit;
begin
     szovegesre;
     clrscr;
     reset(f);
     while not eof(f) do
     begin
          readln(f,sor);
          writeln(sor);
     end;
     writeln('Ha elolvastad, a folytatshoz ss egy <enter>-t!');
     readln;
     grafikusra;
     setfillstyle(1,hatterszin);
     bar(0,0,p1x,p1y);    {szim.neve kerete}
     bar(p1x,0,sx,p1y);   {szim.lepes kerete}
     bar(0,p1y,p2x,p2y);  {szim.ter kerete}
     bar(0,p2y,p3x,p3y);  {grafikon kerete}
     bar(p2x,p1y,sx,p3y); {parameterter kerete}
     bar(0,p3y,sx,sy);    {menu kerete}
end;

procedure menuinit;
begin
     menutomb[1].sorsz:=1;
     menutomb[1].szoveg:='Norml';
     menutomb[1].vegrehajt:=normal;
     menutomb[1].bfx:=8;
     menutomb[1].bfy:=sy-18;
     menutomb[1].jax:=78;
     menutomb[1].jay:=sy-5;
     menutomb[2].sorsz:=2;
     menutomb[2].szoveg:='Csendes';
     menutomb[2].vegrehajt:=csendes;
     menutomb[2].bfx:=78;
     menutomb[2].bfy:=sy-18;
     menutomb[2].jax:=158;
     menutomb[2].jay:=sy-5;
     menutomb[3].sorsz:=3;
     menutomb[3].szoveg:='Graf. ki/be';
     menutomb[3].vegrehajt:=graf;
     menutomb[3].bfx:=158;
     menutomb[3].bfy:=sy-18;
     menutomb[3].jax:=268;
     menutomb[3].jay:=sy-5;
     menutomb[4].sorsz:=4;
     menutomb[4].szoveg:='Lpsenknt';
     menutomb[4].vegrehajt:=lepesenkent;
     menutomb[4].bfx:=268;
     menutomb[4].bfy:=sy-18;
     menutomb[4].jax:=378;
     menutomb[4].jay:=sy-5;
     menutomb[5].sorsz:=5;
     menutomb[5].szoveg:='Paramterek';
     menutomb[5].vegrehajt:=parammodosit;
     menutomb[5].bfx:=378;
     menutomb[5].bfy:=sy-18;
     menutomb[5].jax:=488;
     menutomb[5].jay:=sy-5;
     menutomb[6].sorsz:=6;
     menutomb[6].szoveg:='Kilps';
     menutomb[6].vegrehajt:=kilepes;
     menutomb[6].bfx:=488;
     menutomb[6].bfy:=sy-18;
     menutomb[6].jax:=568;
     menutomb[6].jay:=sy-5;
     menutomb[7].sorsz:=7;
     menutomb[7].szoveg:='Segtsg';
     menutomb[7].vegrehajt:=segit;
     menutomb[7].bfx:=568;
     menutomb[7].bfy:=sy-18;
     menutomb[7].jax:=sx-1;
     menutomb[7].jay:=sy-5;

     aktmenupont:=1;
end;

procedure menukiir;
var i:integer;
begin
     for i:=1 to maxmenupontdb do
     begin
          setfillstyle(1,hatterszin-1);
          bar(menutomb[i].bfx,menutomb[i].bfy,menutomb[i].jax,menutomb[i].jay);
          setfillstyle(1,hatterszin+1);
          bar(menutomb[i].bfx+4,menutomb[i].bfy,menutomb[i].bfx+10,menutomb[i].jay);
          outtextxy(menutomb[i].bfx+4,menutomb[i].bfy+4,menutomb[i].szoveg);
     end;
     setfillstyle(1,hatterszin+5);
     bar(menutomb[aktmenupont].bfx,menutomb[aktmenupont].bfy,menutomb[aktmenupont].jax,menutomb[aktmenupont].jay);
     setfillstyle(1,hatterszin+7);
     bar(menutomb[aktmenupont].bfx+4,menutomb[aktmenupont].bfy,menutomb[aktmenupont].bfx+10,menutomb[aktmenupont].jay);
     outtextxy(menutomb[aktmenupont].bfx+4,menutomb[aktmenupont].bfy+4,menutomb[aktmenupont].szoveg);
end;

procedure kilepes;
var ki:boolean;
begin
     setfillstyle(1,hatterszin);
     bar(1,p3y+1,sx-1,sy-1);
     setfillstyle(1,hatterszin-1);
     bar(100,p3y+10,108,p3y+18);
     bar(180,p3y+10,188,p3y+18);
     bar(260,p3y+10,268,p3y+18);
     outtextxy(100,p3y+10,'Kilps');
     outtextxy(180,p3y+10,'Ellrl');
     outtextxy(260,p3y+10,'Mgse');
     repeat
           ki:=false;
           k:=readkey;
           case k of
                'K': begin
                          ki:=true;
                          kilepo:=true;
                     end;
                'k': begin
                          ki:=true;
                          kilepo:=true;
                     end;
                'E': begin
                          ki:=true;
                          clearviewport;
                          elolrol;
                     end;
                'e': begin
                          ki:=true;
                          clearviewport;
                          elolrol;
                     end;
                'M': begin
                          ki:=true;
                          setfillstyle(1,hatterszin);
                          bar(1,p3y+1,sx-1,sy-1);
                          menukiir;
                     end;
                'm': begin
                          ki:=true;
                          setfillstyle(1,hatterszin);
                          bar(1,p3y+1,sx-1,sy-1);
                          menukiir;
                     end;
           end;
     until ki;
end;

procedure menuzes;
begin
     kilep:=false;
     repeat
           c:=readkey;
           case c of
                #27: begin      {ESC-re}
                          aktmenupont:=6;
                          kilepes;
                          kilep:=true;
                     end;
                #0: begin
                         c:=readkey;
                         case c of
                              #77: begin        {->}
                                   inc(aktmenupont);
                                   if aktmenupont=8 then aktmenupont:=1;
                                   menukiir;
                                   kilep:=true;
                                   end;
                              #75: begin        {<-}
                                   dec(aktmenupont);
                                   if aktmenupont=0 then aktmenupont:=7;
                                   menukiir;
                                   kilep:=true;
                                   end;
                         end;
                    end;
                #13: begin
                          menutomb[aktmenupont].vegrehajt;
                          kilep:=true;
                          cimkiiras;
                          keretek;
                          menukiir;
                     end;
                'N': begin
                     aktmenupont:=1;
                     menukiir;
                     normal;
                     kilep:=true;
                     end;
                'n': begin
                     aktmenupont:=1;
                     menukiir;
                     normal;
                     kilep:=true;
                     end;
                'C': begin
                     aktmenupont:=2;
                     menukiir;
                     csendes;
                     kilep:=true;
                     end;
                'c': begin
                     aktmenupont:=2;
                     menukiir;
                     csendes;
                     kilep:=true;
                     end;
                'G': begin
                     aktmenupont:=3;
                     menukiir;
                     graf;
                     kilep:=true;
                     end;
                'g': begin
                     aktmenupont:=3;
                     menukiir;
                     graf;
                     kilep:=true;
                     end;
                'L': begin
                     aktmenupont:=4;
                     menukiir;
                     lepesenkent;
                     kilep:=true;
                     end;
                'l': begin
                     aktmenupont:=4;
                     menukiir;
                     lepesenkent;
                     kilep:=true;
                     end;
                'P': begin
                     aktmenupont:=5;
                     menukiir;
                     parammodosit;
                     kilep:=true;
                     end;
                'p': begin
                     aktmenupont:=5;
                     menukiir;
                     parammodosit;
                     kilep:=true;
                     end;
                'K': begin
                     aktmenupont:=6;
                     menukiir;
                     kilepes;
                     kilep:=true;
                     end;
                'k': begin
                     aktmenupont:=6;
                     menukiir;
                     kilepes;
                     kilep:=true;
                     end;
                'S': begin
                     aktmenupont:=7;
                     menukiir;
                     kilep:=true;
                     end;
                's': begin
                     aktmenupont:=7;
                     menukiir;
                     kilep:=true;
                     end
                 else  kilep:=true;
           end;
     until kilep;
end;

{-------------menuzes vege-------------------}

procedure elolrol;
var i,j:integer;
    oke:boolean;
begin
     clearviewport;
     keretek;
     ymax:=20;
     grafikontengelyek;
     cimkiiras;
     paramkiir;
     menuinit;
     menukiir;
     kilepo:=false;
     kapcsolo.szt:=true;
     kapcsolo.g:=true;
     kapcsolo.pa:=true;
     kapcsolo.lep:=false;
     szl:=1;

     fele:=p2x div 2;
     A:=elsodoboz;

     if elsodoboz>0 then for j:=1 to elsodoboz do D[j]:=1;
     if elsodoboz<max then for j:=elsodoboz+1 to max do D[j]:=2;
     for j:=max+1 to maxmax do D[j]:=0;

     for j:=1 to maxmax do S[j]:=0;
     S[elsodoboz]:=1;
     if elsodoboz>0 then
        for j:=1 to elsodoboz do
        begin
          repeat
                veletlenhely1;
                i:=1;
                oke:=false;
                while (i<j) and (not oke) do
                begin
                     oke:=((vhelyx=M[i].helyx) and (vhelyy=M[i].helyy));
                     inc(i);
                end;
          until not oke;
          M[j].helyx:=vhelyx;
          M[j].helyy:=vhelyy;
          M[j].doboz:=1;
        end;
     if elsodoboz<max then
        for j:=elsodoboz+1 to max do
        begin
          repeat
                veletlenhely2;
                i:=elsodoboz+1;
                oke:=false;
                while (i<j) and (not oke) do
                begin
                     oke:=((vhelyx=M[i].helyx) and (vhelyy=M[i].helyy));
                     inc(i);
                end;
          until not oke;
          M[j].helyx:=vhelyx;
          M[j].helyy:=vhelyy;
          M[j].doboz:=2;
        end;
     for j:=max+1 to maxmax do
     begin
          M[j].helyx:=0;
          M[j].helyy:=0;
          M[j].doboz:=0;
     end;
end;

begin
     randomize;
     kezdolap;
     grafikusra;
     init;
     clearviewport;
     assign(f,'help.txt');
     elolrol;
     repeat
           if keypressed then
                             begin
                                  menuzes;
                             end;
           if kapcsolo.lep then begin
                            repeat
                                  l:=readkey;
                                  if l=#32 then szimlepes(kapcsolo.szt,kapcsolo.g,kapcsolo.pa,kapcsolo.lep);
                            until l=#13;
                            kapcsolo.lep:=false;
                       end
                  else szimlepes(kapcsolo.szt,kapcsolo.g,kapcsolo.pa,kapcsolo.lep);
     until kilepo;
     szovegesre;
end.