{Barna Edina 2001.03.21.  Darzsmodell}

Program Szimulacio_Keret;
Uses Crt,Graph;
Const Jobbra=#77;
      Balra=#75;
      Fel=#72;
      Le=#80;
      PgUp=#73;
      PgD=#81;
      Esc=#27;
      Enter=#13;
      Space=' ';
      Max=10;
      Mdb=7;
      Mpont: Array [1..Mdb] of String=('Norml','Csendes','Grafikon ki/be','Lpsenknt',
             'Paramterek','Sg','Kilps');
      Fnev='Sugo.txt';
      Spar: Array [1..3] of String=('Gyorsasg:','ssz db:','Elsben:');

Type TMpont=Record
       e,v : Integer;
     End;
    TMenu=Array [1..Max] Of TMpont;
    TSugo=Text;
  {a feladathoz}
    THol=Array [1..100] of Integer;
    THanyszor=Array [0..100] of Integer;

Var path : String;
    fsugo : TSugo;
    szl,szi,s1,s2  : Integer;
    s_szl,s_szi,s_1,s_2 : String;
    x,y:integer;
    szin:integer;
    gyorsasag,ossz,elsoben:Integer;   {paramter modositshoz}
    aktp:Integer;
  {ablak koordintk}
    n_e,n_t,n_v,n_a : integer;            {nv}
    szt_e,szt_t,szt_v,szt_a : integer;    {szim. tr}
    szi_e,szi_t,szi_v,szi_a : integer;    {szim. id}
    p_e,p_t,p_v,p_a : integer;            {paramter}
    g_e,g_t,g_v,g_a : integer;            {grafikon}
    m_t,m_a : Integer;                    {men}
    pm_e,pm_t,pm_v,pm_a : integer;        {paramter mdosit}
    h_e,h_t,h_v,h_a : integer;            {help}
  {menhz}
    kilep:Boolean;
    bill : Char;
    menum : TMenu;
    akt_mp: Integer;
    tipus:Char;  {c:csendes,n:normal,l:lpsenknt}
    graf:Boolean; {Igaz: van grafikon}
    fut:Boolean; {Igaz: mg nincs vge a szimulcinak}

  {a feladathoz}
    N:Integer;    {ssz db darzs}
    D:THol;       {trolja az i. darzs melyik dobozban van}
    A:Integer;    {1 dobozban ennyi darzs van}
    S:THanyszor;  {hnyszor volt x db az 1. dobozban}

 Procedure Szovegesre;
  begin
    CloseGraph;         {lezarja a grafikus uzemmodot}
    RestoreCrtMode;     {Visszaallitja az InitGraph meghivasa elotti
                        kepernyokezelesi modot}
  end;

Procedure Grafikusra;
    Var
       gd,gm : integer;
       hiba:integer;
       kilep:boolean;
       valasz:char;
Begin
     kilep:=False;
     path:={'d:\nyelvek\tp7\bgi';}'c:\langs\tp\bgi';
     Repeat
           DetectGraph(gd,gm);    {detektalja a grafikus eszkozt}
           InitGraph(gd,gm,path); {inicializalja a grafikus rendszert}
           hiba:=GraphResult;
           If hiba<>Grok
              Then
                  Begin
                       ClrScr;
                       GotoXY(2,2);
                       WriteLn('A grafikus mdhoz szksges a Graph.tpu elrsi tja.');
                       Gotoxy(2,3);
                       Write('Kivnja megadni az elrsi utat (i/n)? ');
                       Repeat
                             valasz:=ReadKey;
                       Until (valasz='i') or (valasz='I') or (valasz='n') or
                             (valasz='N');
                       If (valasz='i') or (valasz='I')
                          Then
                              Begin
                                   Gotoxy(2,4);
                                   Write('Az utvonal: ');
                                   ReadLn(path);
                              End
                          Else
                              Begin
                                   kilep:=True;
                              End;
                  End
              Else
                  Begin
                       kilep:=True;
                  End;
     Until kilep;
End;

Procedure SzimLep;
Begin
     szl:=szl+1;
End;

  Procedure Uzenet;
Begin
      SetFillStyle(1,Red);
      Bar(p_e+1,p_a-26,p_v-1,p_a-1);
      SetColor(Black);
      SetTextJustify(1,2);
      OutTextXY(p_e+((p_v-p_e) div 2),p_a-21,'Az egyik dobozbl');
      OutTextXY(p_e+((p_v-p_e) div 2),p_a-11,'elfogytak a darazsak!');

End;

Procedure UzenetKi;
Begin
     SetFillStyle(1,Black);
     Bar(p_e+1,p_a-26,p_v-1,p_a-1);

End;


  Procedure Akt_Parameterek;
  Begin
      {szimulcis lps}
       SetColor(0);
       OutTextXY(p_e+155,p_t+5,s_szl);
       Str(szl,s_szl);
       SetColor(3);
       OutTextXY(p_e+155,p_t+5,s_szl);
      {1. dobozban}
       SetColor(0);
       OutTextXY(p_e+155,p_t+25,s_1);
       s1:=A;
       Str(s1,s_1);
       SetColor(3);
       OutTextXY(p_e+155,p_t+25,s_1);
      {2. dobozban}
       SetColor(0);
       OutTextXY(p_e+155,p_t+35,s_2);
       s2:=N-A;
       Str(s2,s_2);
       SetColor(3);
       OutTextXY(p_e+155,p_t+35,s_2);

  End;


  Procedure Ki_Mod_Par;
  Var
      i:Integer;
      sev:Array [1..3] of string;
  Begin
      Str(gyorsasag,sev[1]);
      Str(ossz,sev[2]);
      Str(elsoben,sev[3]);
      For i:=1 To 3 Do
      	Begin
	   If aktp=i
             Then
            	Begin
                   SetfillStyle(1,3);
                   SetColor(Blue);
                End
             Else
            	Begin
                   SetfillStyle(1,Blue);
                   SetColor(3);
                End;
            Bar(pm_e+1,pm_t+((i+3)*15),pm_v-1,pm_t+((i+3)*15)+15);
            OutTextXY(pm_e+5,pm_t+((i+3)*15)+5,spar[i]);
	         OutTextXY(pm_e+90,pm_t+((i+3)*15)+5,sev[i]);
        End;
  End;

  Procedure Mod_Parameter;
  var
      c:Char;
      i:Integer;
  Begin
       aktp:=1;
       ossz:=30;
       elsoben:=10;
       Ki_Mod_Par;
       Repeat
          Repeat
          	c:=Readkey;
          Until (c=Fel) Or (c=Le) Or (c=Jobbra) Or (c=Balra) Or (c=PgUp) Or
                (c=PgD) Or (c=Esc) Or (c=Enter);
          Case c Of
            Fel : Begin
          	    If aktp>1
                      Then
                         Begin
          		      aktp:=aktp-1;
                         End
                      Else
                      	 Begin
                              aktp:=3;
                         End;
            	   End;
            Le : Begin
            	   If aktp<3
                      Then
                        Begin
            		     aktp:=aktp+1;
                        End
                      Else
                      	Begin
                             aktp:=1;
                        End;
                  End;
            Balra : Begin
                      Case aktp Of
                       	1: Begin
                                If gyorsasag>10
                                   Then
                                       Begin
                      		            gyorsasag:=gyorsasag-10;
                                       End;
                       	   End;
                        2: Begin
                                If ossz>=2
                                   Then
                                       Begin
                      		            ossz:=ossz-1;
                                       End;
                           End;
                        3: Begin
                                If elsoben>=2
                                   Then
                                       Begin
                        	            elsoben:=elsoben-1;
                                       End;
                           End;
                      End;
                    End;
            Jobbra : Begin
            		Case aktp Of
                       	1: Begin
      		            gyorsasag:=gyorsasag+10;
                       	   End;
                        2: Begin
                                If ossz<=99
                                   Then
                                       Begin
                      		            ossz:=ossz+1;
                                       End;
                           End;
                        3: Begin
                                If elsoben<=ossz-1
                                   Then
                                       Begin
                        	            elsoben:=elsoben+1;
                                       End;
                           End;
                        End;
                     End;
            PgD : Begin
                      Case aktp Of
                       	1: Begin
                                If gyorsasag>100
                                   Then
                                       Begin
                      		            gyorsasag:=gyorsasag-100;
                                       End;
                       	   End;
                        2: Begin
                                If ossz>=10
                                   Then
                                       Begin
                      		            ossz:=ossz-10;
                                       End;
                           End;
                        3: Begin
                                If elsoben>=10
                                   Then
                                       Begin
                        	            elsoben:=elsoben-10;
                                       End;
                           End;

                      End;
                   End;
            PgUp : Begin
            		Case aktp Of
                       	1: Begin
      		            gyorsasag:=gyorsasag+100;
                       	   End;
                        2: Begin
                                If ossz<=90
                                   Then
                                       Begin
                      		            ossz:=ossz+10;
                                       End;
                           End;
                        3: Begin
                                If elsoben<=ossz-10
                                   Then
                                       Begin
                        	            elsoben:=elsoben+10;
                                       End;
                           End;

                        End;
                     End;

          End;
          Ki_Mod_Par;
       Until (c=Esc) Or (c=Enter);
       If c=Enter
          Then
              Begin
                 N:=ossz;
                 A:=elsoben;
                 For i:=0 to 100 do
                     Begin
                          S[i]:=0;
                     End;
                 fut:=True;
                 UzenetKi;
              End;
  End;

  Procedure SzimIdo;
  Begin
       SetTextJustify(0,2);
       SetColor(0);
       OutTextXY(szi_e+140,szi_t+5,s_szi);
       szi:=szi+1;
       Str(szi,s_szi);
       SetTextJustify(0,2);
       SetColor(3);
       OutTextXY(szi_e+140,szi_t+5,s_szi);
       Delay(gyorsasag);
  End;

  Procedure SzimNev(szimulacio_nev:String);
  Var x,y:Integer;

  Begin
       szin:=Getcolor;
      {szim nv ablakkoordintk}
       n_e:=5; n_t:=5; n_v:=GetMaxX-5; n_a:=25;
      {szim nv ablak}
       SetfillStyle(1,1);
       Bar(n_e,n_t,n_v,n_a);
      {szim nv kiirsa}
       x:=Round(((n_v-n_e)/2));
       y:=n_t+Round((n_a-n_t)/2);
       SetTextJustify(1,1);
       SetColor(15);
       OutTextXY(x,y,szimulacio_nev);
       SetColor(szin);
  End;

  Procedure Ablakok(szimter:Boolean; parameter:Boolean; grafikon:Boolean);

  Begin
       szin:=GetColor;
       setcolor(7);
     {szimid ablakkoordintk}
       szi_e:=415; szi_t:=35; szi_v:=GetMaxX-5; szi_a:=55;
     {szimid ablak}
       Rectangle(szi_e,szi_t,szi_v,szi_a);
       SetTextJustify(0,2);
       OutTextXY(szi_e+5,szi_t+5,'Szimulcis id: ');
       Str(szi,s_szi);
       SetColor(3);
       OutTextXY(szi_e+140,szi_t+5,s_szi);

       setcolor(7);
       If szimter
          Then
            Begin
             {szimtr ablakkoordintk}
              szt_e:=5; szt_t:=35; szt_v:=405; szt_a:=205;
             {szimtr ablak}
              Rectangle(szt_e,szt_t,szt_v,szt_a);
{              SetfillStyle(1,1);
              Bar(szt_e,szt_t,szt_v,szt_a);}
            End;
       If grafikon
          Then
            Begin
             {grafikon ablakkoordintk}
              g_e:=5; g_t:=szt_a+10; g_v:=GetMaxX-5; g_a:=GetMaxY-35;
             {grafikon ablak}
              Rectangle(g_e,g_t,g_v,g_a);
            End;
       If parameter
          Then
            Begin
             {paramter ablakkoordintk}
              p_e:=415; p_t:=65; p_v:=GetMaxX-5; p_a:=szt_a;
             {paramter ablak}
              Rectangle(p_e,p_t,p_v,p_a);
{              SetfillStyle(1,1);
              Bar(p_e,p_t,p_v,p_a);}
             {szimulcis lps}
               SetTextJustify(0,2);
               OutTextXY(p_e+5,p_t+5,'Szimulcis lps: ');
               Str(szl,s_szl);
               SetColor(3);
               OutTextXY(p_e+155,p_t+5,s_szl);
             {1. dobozban}
               SetTextJustify(0,2);
               SetColor(7);
               OutTextXY(p_e+5,p_t+25,'Els dobozban: ');
               s1:=A;
               Str(s1,s_1);
               SetColor(3);
               OutTextXY(p_e+155,p_t+25,s_1);
             {2. dobozban}
               SetTextJustify(0,2);
               SetColor(7);
               OutTextXY(p_e+5,p_t+35,'Msodik dobozban: ');
               s2:=N-A;
               Str(s2,s_2);
               SetColor(3);
               OutTextXY(p_e+155,p_t+35,s_2);

            End;
     {help ablakkoordintk}
       h_e:=100; h_t:=100; h_v:=540; h_a:=380;
       SetColor(szin);
  End;

  Procedure MenuInic;
  Var szeles : Integer;
      i :Integer;
  Begin
      {menu ablakkoordintk}
       m_t:=GetMaxY-25; m_a:=GetMaxY-5;
       szeles:=TextWidth(mpont[1])+20;
       menum[1].e:=5; menum[1].v:=menum[1].e+szeles;
       For i:=2 To Mdb Do
           Begin
                menum[i].e:=menum[i-1].v;
                szeles:=TextWidth(mpont[i])+20;
                menum[i].v:=menum[i].e+szeles;
           End;
   {alap belltsok}
     akt_mp:=5;
     tipus:='n';
     graf:=True;
     kilep:=False;
   {paramter mdositablak koordintk}
     pm_e:=menum[5].e-35; pm_t:=250; pm_v:=menum[5].v+35; pm_a:=m_t-1;
   {helphez}
     Assign(fsugo,fnev);
  End;

  Procedure MenuKi;
  Var i : Integer;
  Begin
      {menupontok kiirsa}
       For i:=1 To Mdb Do
          Begin
            If i=akt_mp
              Then
                Begin                   {aktulis menpont}
                    SetfillStyle(1,3);
                    If ((i=1) and (tipus='n')) OR ((i=2) and (tipus='c'))
                       OR ((i=4) and (tipus='l'))
                       Then
                           SetColor(5)
                       Else
                           SetColor(1);
                End
              Else
                Begin                   {nem aktulis menpont}
                    SetfillStyle(1,1);
                    If ((i=1) and (tipus='n')) OR ((i=2) and (tipus='c'))
                       OR ((i=4) and (tipus='l'))
                       Then
                           SetColor(4)
                       Else
                           SetColor(3);

                End;
            Bar(menum[i].e,m_t,menum[i].v,m_a);
            SetTextJustify(1,1);
            x:=menum[i].e+Round(((menum[i].v-menum[i].e)/2));
            y:=m_t+Round((m_a-m_t)/2);
            OutTextXY(x,y,Mpont[i]);
          End;
       settextjustify(0,2);
  End;


  Procedure Menu;
  Var x,y,i :Integer;
      p : Pointer;
      sug:String;
      sor:Integer;

  Begin
       szin:=GetColor;
     {Mozgs}
       Repeat
             bill:=ReadKey;
       Until bill in [Jobbra,Balra,Esc,Enter,Space];
       Case bill Of
            Balra : Begin
                       If akt_mp>1
                          Then
                            Begin
                                 akt_mp:=akt_mp-1;
                            End
                          Else
                            Begin
                                 akt_mp:=7;
                            End;
                     End;
            Jobbra : Begin
                      If akt_mp<7
                         Then
                           Begin
                                akt_mp:=akt_mp+1;
                           End
                         Else
                           Begin
                                akt_mp:=1;
                           End;
                    End;
            Enter : Begin
                      Case akt_mp Of
                           1: Begin  {Norml}
                                   tipus:='n';
                                   graf:=True;
                              End;
                           2: Begin  {Csendes}
                                   tipus:='c';
                                   graf:=False;
                              End;
                           3: Begin  {Grafikon}
                                   graf:=Not(graf);
                              End;
                           4: Begin  {Lpsenknt}
                                   tipus:='l';
                              End;
                           5: Begin  {Paramter mdostsok}
                                   GetImage(pm_e,pm_t,pm_v,pm_a,P^);
                                   SetColor(3);
                                   Rectangle(pm_e,pm_t,pm_v,pm_a);
                                   SetfillStyle(1,Blue);
                                   SetTextJustify(0,2);
                                   Bar(pm_e+1,pm_t+1,pm_v-1,pm_a-1);
                                   SetColor(White);
				   												 OutTextXY(pm_e+5,pm_t+5,'Fel:,  Le: ');
				   								         OuttextXY(pm_e+5,pm_t+15,'Nvel:->,PgUp');
                                   OuttextXY(pm_e+5,pm_t+25,'Cskkent:<-,PgD');
                                   OuttextXY(pm_e+5,pm_t+35,'jra:Enter, Mgse:Esc');
                                   Line(pm_e+1,pm_t+45,pm_v-1,pm_t+45);
                                   Mod_Parameter;
                                   Delay(200);
                                   PutImage(pm_e,pm_t,P^,normalput);
                              End;
                           6: Begin  {Sg}
                                   GetImage(h_e,h_t,h_v,h_a,P^);
                                   SetColor(3);
                                   Rectangle(h_e,h_t,h_v,h_a);
                                   SetfillStyle(1,Blue);
                                   Bar(h_e+1,h_t+1,h_v-1,h_a-1);
                                   SetColor(white);
                                   SetTextJustify(1,2);
                                   OutTextXY(h_e+((h_v-h_e) div 2),h_t+5,'SG');
                                   SetTextJustify(0,2);
                                   sor:=h_t+10;
                                   Reset(fsugo);
                                   While Not Eof(fsugo) Do
                                         Begin
                                              sor:=sor+15;
                                              ReadLn(fsugo,sug);
                                              OutTextXY(h_e+5,sor,sug);
                                         End;
                                   readkey;
                                   PutImage(h_e,h_t,P^,normalput);
                              End;
                           7: Begin  {Kilps}
                                   kilep:=True;
                              End;
                      End;
                    End;
            Esc : Begin
                       kilep:=True;
                  End;
            Space: Begin
                        If (akt_mp=4) and (tipus='l')
                           Then
                             Begin

                             End;
                   End;
       End;
     MenuKi;
     SetColor(szin);
  End;

Procedure Diagram(bfx,bfy,jax,jay:Integer;tomb:THanyszor;elemsz:Byte; tengely:Boolean;
          felirat:Boolean; szin:Byte);
Var egysegX,egysegy,i,max:Integer;
    sv:string;

Begin
     SetfillStyle(1,Black);
     Bar(g_e+1,g_t+1,g_v-1,g_a-1);
     SetfillStyle(1,szin);
     egysegx:=Round((jax-bfx)/(elemsz+1));
     max:=(jay-g_t) div 2;
     egysegy:=Round((jay-bfy)/max);
     For i:=0 To elemsz-1 Do
         Begin
              If tomb[i]>max-10
               Then
                 Begin
                      Bar(bfx+((i)*egysegx),jay-((max-10)*egysegy),bfx+((i+1)*egysegx),jay);
                 End
               Else
                 Begin
                      Bar(bfx+((i)*egysegx),jay-(tomb[i]*egysegy),bfx+((i+1)*egysegx),jay);
                 End;
         End;
		 SetColor(3);
     If tengely
        Then
            Begin
               {tengelyek}
                 Line(bfx,bfy,bfx,jay);
                 Line(bfx,jay,jax,jay);
               {tengely nyilak}
                 Line(bfx,bfy,bfx-4,bfy+4);
                 Line(bfx,bfy,bfx+4,bfy+4);
                 Line(jax,jay,jax-4,jay-4);
                 Line(jax,jay,jax-4,jay+4);
               {tengely nv}
                 SetTextStyle(2,0,4);
                 OutTextXY(bfx+10,bfy,'Hnyszor volt'); {Y}
                 OutTextXY(jax+10,jay,'Darazsak szma az 1. dobozban'); {X}
               {X tengelyre szmozs}
                 SetTextStyle(2,1,2);
                 For i:=0 To elemsz Do
                     Begin
                          Str(i,sv);
                          OutTextxy(bfx+(i*egysegx)+(egysegx div 3),jay+10,sv);
                     End;
                 SetTextStyle(0,0,0);
               {egysgek az X tengelyre}
                 For i:=0 To elemsz Do
                     Begin
                          Line(bfx+(i*egysegx),jay-4,bfx+(i*egysegx),jay+4);
                     End;
               {egysgek az Y tengelyre}
                 For i:=0 To max-10 Do
                     Begin
                          Line(bfx-4,jay-(i*egysegy),bfx+4,jay-(i*egysegy));
                     End;
            End;
     If felirat
        Then
            Begin
                 For i:=0 To Elemsz Do
                     Begin
                          Str(tomb[i],sv);
                          If tomb[i]>max-10
                            Then
                              Begin
                                   SetTextStyle(2,1,2);
                                   SetTextJustify(2,1);
                                   OutTextxy(bfx+(i*egysegx)+(egysegx div 2),g_t+10,sv);
                              End
                            Else
                              Begin
                                   SetTextStyle(2,0,2);
                                   SetTextJustify(1,2);
                                   OutTextxy(bfx+(i*egysegx)+(egysegx div 2),jay-(tomb[i]*egysegy)-15,sv);
                              End;


                     End;
                 SetTextStyle(0,0,0);
            End;
    SetTextJustify(0,0);
End;

Procedure DarazsGen;
Var i,j:Integer;
Begin
     ClrScr;
     Write('Mennyi darzs legyen: ');
     Repeat
           ReadLn(N);
     Until N<=100;
     Write('Mennyi darzs legyen az els dobozban: ');
     Repeat
           ReadLn(A);
     Until A<=N;
     S[A]:=1;
     For i:=1 to N Do
       Begin
            j:=Random(2)+1;
            D[i]:=j;
       End;
End;

Procedure DarazsLep;
Var i:Integer;
Begin
     i:=Random(N)+1;
     If D[i]=1
        Then
          Begin
               D[i]:=2;
               A:=A-1;
               S[A]:=S[A]+1;
          End
        Else
          Begin
               D[i]:=1;
               A:=A+1;
               S[A]:=S[A]+1;
          End;

End;
Procedure DarazsRajz;
Var dx,dy:Integer;
    vx:Integer;
    i:Integer;
Begin
    SetfillStyle(1,Black);
    Bar(szt_e+1,szt_t+1,szt_v-1,szt_a-1);
    vx:=round((szt_e+szt_v)/2);
    line(vx,szt_t,vx,szt_a);

     For i:=1 to A do
         Begin
            dx:=Random(vx-szt_e-1)+szt_e+1;
            dy:=Random(szt_a-szt_t-1)+szt_t+1;
            PutPixel(dx,dy,White);
         End;
     For i:=1 to (N-A) do
         Begin
            dx:=Random(szt_v-vx-1)+vx+1;
            dy:=Random(szt_a-szt_t-1)+szt_t+1;
            PutPixel(dx,dy,White);
         End;

End;


BEGIN
     DarazsGen;
     Grafikusra;
     Randomize;
     SzimNev('Darazsak vndorlsa');
     Ablakok(true,true,true);
     MenuInic;
     MenuKi;
     Delay(1700);
     gyorsasag:=200;
     fut:=True;
     Repeat
         If fut
            Then
               Begin
                {Paramterek}
                  If (tipus<>'c')
                    Then
                      Begin
                          Akt_Parameterek;
                      End;

                {Grafikon}
                  If (graf)
                    Then
                      Begin
                          Diagram(40,g_t+10,440,g_a-25,S,N,true,true,1);
                      End;


                {Szimulcis Lps}
                  If (A=0) OR (A=N)
                   Then
                     Begin
                       Uzenet;
                       fut:=False;
                     End
                   Else
                     Begin
                       SzimLep;
                       DarazsLep;
                       DarazsRajz;
                       SzimIdo;
                     End;

               End;
        {menzs}
           If KeyPressed
             Then
               Begin
                    Menu;
               End;
     Until kilep;
     Szovegesre;

END.