unit o_dgrm;

INTERFACE

uses
  crt, graph;

var
  sx, sy, ox, oy : integer;
  xmax, xmin, ymax, ymin : real;
  nx, ny : real; {nyjtsi tnyez}
  dx, dy : real;


  PROCEDURE diagram(db : integer; x, y : array of integer; a_bfx, a_bfy, a_jax, a_jay : integer);


IMPLEMENTATION





Procedure Maxmin(db : integer; x, y : array of integer; var xmax, xmin, ymax, ymin : real);
  var
    i : integer;

  begin
    xmax := x[0];
    xmin := x[0];
    ymax := y[0];
    ymin := y[0];
    i := 1;
    while (i < db) do
      begin
        if (x[i] > xmax)
          then
            begin
              xmax := x[i];
            end {AKKOR-g vge}
          else
            begin
              if (x[i] < xmin)
                then
                  begin
                    xmin := x[i];
                  end; {elgazs vge}
            end; {elgazs vge}
        if (y[i] > ymax)
          then
            begin
              ymax := y[i];
            end {AKKOR-g vge}
          else
            begin
              if (y[i] < ymin)
                then
                  begin
                    ymin := y[i];
                  end; {elgazs vge}
            end; {elgazs vge}
        inc(i);
      end; {ciklus vge}
  end; {Maxmin eljrs vge}


Procedure Koordteng(a_bfx, a_bfy, a_jax, a_jay, ox, oy : integer); {koordinta-tengelyek kirajzolsa}
  begin
    line(a_bfx, oy, a_jax, oy);
    line(ox, a_jay, ox, a_bfy);
  end;


Procedure Tartomany(var dx, dy : real);
          {az brzolsi tartomny meghatrozsa}
  var
    seg : real;
  begin
    dx := abs(xmax);
    seg := abs(xmin);
    if (seg > dx)
      then
        begin
          dx := seg;
        end; {elgazs vge}
    dy := abs(ymax);
    seg := abs(ymin);
    if (seg > dy)
      then
        begin
          dy := seg;
        end; {elgazs vge}
  end;


Procedure Teglalaprajzolas(x, y : real; szel, alja : integer);
  var
    oszlop, sor : real;
    bfx, bfy, jax, jay : integer;

  begin
    oszlop := ox + x;
    sor := oy - y;
    bfx := round(oszlop - (szel / 2));
    bfy := round(sor);
    jax := round(oszlop + (szel / 2));
    jay := alja;
    bar(bfx, bfy, jax, jay);
  end;


Procedure Rajzolas(db : integer; x, y : array of integer; a_bfx, a_bfy, a_jax, a_jay : integer);
  {kpernyre normls az orig helybenhagysval, tglalapokkal}

  var
    i : integer;

  begin
    Maxmin (db, x, y, xmax, xmin, ymax, ymin);
    Tartomany(dx, dy);

    ox := a_bfx + round((a_jax - a_bfx) / 2);
    oy := a_jay + round((a_bfy - a_jay) / 2);
    nx := ((a_jax - a_bfx) / (2 * dx));
    ny := ((a_jay - a_bfy) / (2 * dy));
    {A nyjtsi tnyezk "egysgestse"}
{    if (nx > ny)
      then
        begin
          nx := ny;
        end
      else
        begin
          if (ny > nx)
            then
              begin
                ny := nx;
              end;
        end;}
    Koordteng(a_bfx, a_bfy, a_jax, a_jay, ox, oy);
    for i := 0 to (db - 1) do
      begin
        Teglalaprajzolas((x[i] * nx), (y[i] * ny), round(0.5 * ny), oy);
      end;
  end;



PROCEDURE diagram(db : integer; x, y : array of integer; a_bfx, a_bfy, a_jax, a_jay : integer);
  begin
    rectangle(a_bfx, a_bfy, a_jax, a_jay);
    rajzolas(db, x, y, a_bfx, a_bfy, a_jax, a_jay);
  end;


BEGIN

END.


