program sz_ker;

uses
  crt, sz_k01, o_dgrm, graph;

const
  o = 10;
  p = 10;
  maxn = o * p;

var
  maxX, maxY : integer; {a kperny mrete}
  cim : string; {BGI fjlok cme}
  k : keret; {a keret nevezetes pontjeai}
  a : adat; {adatvektor}
  ch1, ch2 : char;
  kar : char;
  d : array[1..maxn] of integer;
  s : array[1..maxn] of integer;
  bf, ja, gbf, gja : pont;
  x : integer;
  jobb : array[1..o, 1..p] of boolean; {jobb oldali doboz}
  bal : array[1..o, 1..p] of boolean; {bal oldali doboz}
  xx : array[1..maxn] of  integer;



Procedure KepRajzol(b_f, j_a : pont; f : integer);
  var
    xx, yy : real;
    i, j : integer;
    fx, fy, ax, ay : integer;

  begin
    SetFillStyle(1, 15);
    xx := (j_a.x - b_f.x) / (2 * o);
    yy := (j_a.y - b_f.y) / p;
    for i := 1 to 5 do
      begin
        for j := 1 to 5 do
          begin
            if (bal[i, j] = true)
              then
                begin
                  fx := b_f.x + round((i - 1) * xx) + 5;
                  fy := b_f.y + round((j - 1) * yy) + 5;
                  ax := round(fx + xx - 10);
                  ay := round(fy + yy - 10);
                  Bar(fx, fy, ax, ay);
                end;
            if (jobb[i, j] = true)
              then
                begin
                  fx := b_f.x + round((i - 1 + 5) * xx) + 5;
                  fy := b_f.y + round((j - 1) * yy) + 5;
                  ax := round(fx + xx - 10);
                  ay := round(fy + yy - 10);
                  Bar(fx, fy, ax, ay);
                end;
          end;
      end;
  end;


Procedure GrafikonRajzol(b_f, j_a : pont);
  var
    fx, fy, ax, ay : integer;

  begin
    fx := b_f.x + 10;
    fy := b_f.y + 10;
    ax := j_a.x - 10;
    ay := j_a.y - 10;
    Rectangle(fx, fy, ax, ay);
    SetFillStyle(0, 15);
    bar((fx + 1), (fy + 1), (ax - 1), (ay - 1));
    SetFillStyle(1, 15);
    diagram(a[4], xx, s, (fx + 2), (fy + 2), (ax - 2), (ay - 2));
  end;




Procedure ParameterAllit;
  var
    ch : char;

  begin
    repeat
      SetViewPort(376, (maxY - 221), 576, (maxY - 21), ClipOn);
      ClearViewPort;
      Rectangle(0, 0, 200, 200);
      SetTextJustify(CenterText, CenterText);
      OutTextXY(100, 100, 'Paramterdoboz');
      repeat
      until (KeyPressed);
      ch := ReadKey;
    until (ch = #13);
    SetViewPort(0, 0, maxX, maxY, ClipOn);
    ClearViewPort;
  end;


Procedure TerRajzol(kk : keret; var b_f, j_a : pont; var x : integer);
  begin
    b_f.x := k.x1 + 10;
    b_f.y := k.y2 + 10;
    j_a.x := k.x4 - 10;
    j_a.y := k.y3 - 10;
    Rectangle(b_f.x, b_f.y, j_a.x, j_a.y);
    x := round((b_f.x + j_a.x) / 2);
    Line(x, b_f.y, x, j_a.y);

  end;




Procedure VeletlenHely(maxs, maxo, plusz : integer; var sor, oszlop : integer);
  begin
    randomize;
    sor := random(maxs) + 1;
    oszlop := random(maxo) + 1 + plusz;
  end;


Procedure AdatGeneral;
  var
    i, j, l, m : integer;

  procedure SzamOlvas(sor : integer; max : integer; var szam : integer);
    var
      sz : string[4];
      szam0, szam1 : integer;
      pozicio : integer;
      i : integer;
      ch : char;

    begin
      sz := '';
      val(sz, szam0, pozicio);
      i := 0;
      repeat
        repeat
          ch := ReadKey;
          if (ch in szamjegyek)
            then
              begin
                val(ch, szam1, pozicio);
                if (((szam0 * 10) + szam1) <= max)
                  then
                    begin
                      sz := sz + ch;
                      OutTextXY((314 + (i * 8)), sor, ch);
                      inc(i);
                    end;
              end;
        until ((ch in szamjegyek) or (ch = #13));
        val(sz, szam0, pozicio);
      until (ch = #13);
      szam := szam0;
    end;


  begin
    for i := 1 to maxn do
      begin
        xx[i] := i;
      end;


    for i := 1 to o do
      begin
        for j := 1 to p do
          begin
            bal[i, j] := false;
            jobb[i, j] := false;
          end;
      end;

    for i := 1 to a[4] do
      begin
        s[i] := 0;
      end;

    SetTextJustify(LeftText, CenterText);
    OutTextXY(56, 20, 'A dobozokba zrt darazsak szma: ');
    SzamOlvas(20, maxn, a[4]);
    OutTextXY(40, 40, 'Az 1. dobozba zrt darazsak szma: ');
    SzamOlvas(40, a[4], a[5]);
    inc(s[a[5]]);


    for i := 1 to a[4] do
      begin
        d[i] := 2;
      end;


    for i := 1 to a[5] do
      begin
        repeat
          j := random(a[4] + 1);
        until (d[j] = 2);
        d[j] := 1;
      end;

    for i := 1 to a[5] do
      begin
        repeat
          VeletlenHely(o, p, 0, l, m);
        until (bal[l, m] = false);
        bal[l, m] := true;
      end;

    for i := (a[5] + 1) to a[4] do
      begin
        repeat
          VeletlenHely(o, p, 0, l, m);
        until (jobb[l, m] = false);
        jobb[l, m] := true;
      end;

    ClearViewPort;
  end;



Procedure Lepesek(var aa : adat; var ch1 : char);
  var
    j : integer;
    sz : string[5];
    ch2 : char;


  procedure SzimLep(var a : adat);
    var
      i : integer;
      j : integer;
      l, m : integer;

    begin
      i := (random(a[4]) + 1);
      if (d[i] = 1)
        then
          begin
            d[i] := 2;
            dec(a[5]);
            inc(s[a[5]]);
            repeat
              VeletlenHely(o, p, 0, l, m);
            until (bal[l, m] = true);
            bal[l, m] := false;
            repeat
              VeletlenHely(o, p, 0, l, m);
            until (jobb[l, m] = false);
            jobb[l, m] := true;
          end
        else
          begin
            d[i] := 1;
            inc(a[5]);
            inc(s[a[5]]);
            repeat
              VeletlenHely(o, p, 0, l, m);
            until (jobb[l, m] = true);
            jobb[l, m] := false;
            repeat
              VeletlenHely(o, p, 0, l, m);
            until (bal[l, m] = false);
            bal[l, m] := true;
          end;


      inc(a[3]);
      SetFillStyle(0, 0);
      Bar(425, 1, 480, 19);
      str(a[3], sz);
      OutTextXY(480, 10, sz);
      SetFillStyle(0, 0);
      bar((bf.x + 1), (bf.y + 1), (x - 1), (ja.y - 1));
      bar((x + 1), (bf.y + 1), (ja.x - 1), (ja.y - 1));
      KepRajzol(bf, ja, x);
      GrafikonRajzol(gbf, gja);
    end;

  procedure kilo(var c1, c2 : char);
    begin
      c1 := #0;
      c2 := #0;
    end;

  begin
    SetTextJustify(RightText, CenterText);
    repeat
      case (aa[1]) of
        1 : begin
              repeat
                repeat
                  SzimLep(aa);
                  delay(500);
                until (keypressed);
                ch1 := ReadKey;
                if (ch1 = #0)
                  then
                    begin
                      ch2 := readkey;
                    end
                  else
                    begin
                      if ((ch1 = 'n') or (ch1 = 'N'))
                        then
                          begin
                            kilo(ch1, ch2);
                          end;
                    end;
              until ((ch1 in m_b) or ((ch1 = #0) and ((ch2 = #75) or (ch2 = #77))));
            end;
        2 : begin
              repeat
                repeat
                  SzimLep(aa);
                  delay(500);
                 until (KeyPressed);
                ch1 := ReadKey;
                if (ch1 = #0)
                  then
                    begin
                      ch2 := readkey;
                    end
                  else
                    begin
                      if ((ch1 = 'c') or (ch1 = 'C'))
                        then
                          begin
                            kilo(ch1, ch2);
                          end;
                    end;
              until ((ch1 in m_b) or ((ch1 = #0) and ((ch2 = #75) or (ch2 = #77))));
            end;
        3 : begin
              repeat
                repeat
                  SzimLep(aa);
                  delay(500);
                until (KeyPressed);
                ch1 := ReadKey;
                if (ch1 = #0)
                  then
                    begin
                      ch2 := readkey;
                    end
                  else
                    begin
                      if ((ch1 = 'g') or (ch1 = 'G'))
                        then
                          begin
                            kilo(ch1, ch2);
                          end;
                    end;
              until ((ch1 in m_b) or ((ch1 = #0) and ((ch2 = #75) or (ch2 = #77))));
            end;
        4 : begin
              repeat
                SzimLep(aa);
                repeat
                  repeat
                  until (KeyPressed);
                  ch1 := ReadKey;
                  if (ch1 = #0)
                    then
                      begin
                        ch2 := ReadKey;
                      end
                    else
                      begin
                        if ((ch1 = 'l') or (ch1 = 'L'))
                          then
                            begin
                              kilo(ch1, ch2);
                            end;
                      end;
                until ((ch1 = #32) or ((ch1 in m_b) or ((ch1 = #0) and ((ch2 = #75) or (ch2 = #77)))));
              until ((ch1 in m_b) or ((ch1 = #0) and ((ch2 = #75) or (ch2 = #77))));
            end;
      end;
      Ugraszt(ch1, ch2, aa[1]);
    until ((ch1 in m_b) or ((ch1 = #0) and ((ch2 = #75) or (ch2 = #77))));
    KeretCserel(maxY, a);
  end;


BEGIN
  clrscr;
  GrafikusRa(path, maxX, maxY);
  FajlKiIr('tajek.txt');
  a[1] := 5;
  a[2] := 0;
  a[3] := 0;{szimulcis lps szmll}
  AdatGeneral;
  kar := #0;
  cim := 'Darzsmodell';
  KeretGeneral(maxX, maxY, cim, k, a);
  gbf.x := k.x1;
  gbf.y := k.y3;
  gja.x := k.x5;
  gja.y := k.y4;
  TerRajzol(k, bf, ja, x);
  KepRajzol(bf, ja, x);
  GrafikonRajzol(gbf, gja);
  keretez(maxY, a[1]);
  a[2] := a[1];
  MenuMozgat(kar, maxY, a);
  repeat
    if ((a[1] = 1) or (a[1] = 2) or (a[1] = 3) or (a[1] = 4))
      then
        begin
          Lepesek(a, kar);
        end
      else
        begin
          if (a[1] = 5)
            then
              begin
                ParameterAllit;
                Folytat(maxX, maxY, cim, k, a);
                TerRajzol(k, bf, ja, x);
                KepRajzol(bf, ja, x);
                GrafikonRajzol(gbf, gja);
                kar := #0;
              end;
          if (a[1] = 6)
            then
              begin
                FajlKiIr('help.txt');
                Folytat(maxX, maxY, cim, k, a);
                TerRajzol(k, bf, ja, x);
                kar := #0;
              end;
        end;
    if (kar = #0)
      then
        begin
          MenuMozgat(kar, maxY, a);
        end;
  until (a[1] = 7);
{  readln;}
  SzovegesRe;
END.



