Program darazs;
uses crt,graph;
  const
       max=1000;
Type tomb=array [1..max] of byte;
var szi:integer;
    hol,elemszam:integer;
    s,seged,kilepo:char;
    n,a:integer;
    d,t:tomb;
    path:string;

Procedure Szovegesre;
  begin
    CloseGraph;         {lezarja a grafikus uzemmodot}
    RestoreCrtMode;     {Visszaallitja az InitGraph meghivasa elotti
                         kepernyokezelesi modot}
  end;

Procedure Grafikusra;
    Var
       gd,gm : integer;
       hiba:integer;
       kilep:boolean;
       valasz:char;
Begin
     kilep:=False;
     path :={'c:\turbo7\bin';}
          'c:\langs\tp\bgi';
     Repeat
           DetectGraph(gd,gm);    {detektalja a grafikus eszkozt}
           InitGraph(gd,gm,path); {inicializalja a grafikus rendszert}
           hiba:=GraphResult;
           If hiba<>Grok
              Then
                  Begin
                       ClrScr;
                       GotoXY(2,2);
                       WriteLn('A grafikus mdhoz szksges a Graph.tpu elrsi tja.');
                       Gotoxy(2,3);
                       Write('Megadja az elrsi utat (i/n)? ');
                       Repeat
                             valasz:=ReadKey;
                       Until (valasz='i') or (valasz='I') or (valasz='n') or
                             (valasz='N');
                       If (valasz='i') or (valasz='I')
                          Then
                              Begin
                                   Gotoxy(2,4);
                                   Write('Az tvonal: ');
                                   ReadLn(path);
                              End
                          Else
                              Begin
                                   kilep:=True;
                              End;
                  End
              Else
                  Begin
                       kilep:=True;
                  End;
     Until kilep;
End;


Procedure feltolt;
var i:integer;
Begin
     Repeat
           WriteLn('Krem a darazsak maximlis szmt:');
           ReadLn(n);
     Until (n<=max);
     Repeat
           WriteLn('Krem az 1.dobozba lv darazsak szmt:');
           ReadLn(a);
     Until (a<=n);
     For i:=1 to a do
         Begin
              d[i]:=1;
         End;
     For i:=a+1 to n do
         Begin
              d[i]:=2;
         End;
End;


Procedure szimnev(x,y:integer; nev:string);
Begin
     setfillstyle(solidfill,blue);
     bar(x-5,y-5,x+550,y+10);
     setcolor(yellow);
     outtextxy(x+170,y,nev);
End;

Procedure szimter(bfx,bfy,jax,jay:integer);
var fx,x,y,i:integer;
Begin
     randomize;
     setfillstyle(solidfill,black);
     bar(bfx,bfy,jax,jay);
     rectangle(bfx,bfy,jax,jay);
     fx:=round((bfx+jax)/2);
     setcolor(yellow);
     line(fx,bfy,fx,jay);
     For i:=1 to a do
     	Begin
     		x:=random(fx-bfx-1)+bfx+1;
     		y:=random(jay-bfy-1)+bfy+1;
     		putpixel(x,y,white);
      End;
     For i:=a+1 to n do
     	Begin
     		  x:=random(jax-fx-1)+fx+1;
     		  y:=random(jay-bfy-1)+bfy+1;
     		  putpixel(x,y,white);
      End;
     setcolor(yellow);
     rectangle(bfx,bfy,jax,jay);
     setfillstyle(solidfill,blue);
End;

Procedure grafikon(bfx,bfy,jax,jay:Integer;t:tomb;elemsz:Byte; tengely:Boolean;
          felirat:Boolean; szin:Byte);
Var egysegX,egysegy,i,max,g_e,g_t,g_v,g_a:Integer;
    sv:string;
Begin
     g_e:=49;
     g_t:=249;
     g_v:=639;
     g_a:=400;
     SetfillStyle(1,Black);
     Bar(g_e+1,g_t+1,g_v-1,g_a-1);
     SetfillStyle(1,yellow);
     Rectangle(g_e+1,g_t+1,g_v-1,g_a-1);
     SetfillStyle(1,yellow);
     egysegx:=Round((jax-bfx)/(elemsz+1));
     max:=(jay-g_t) div 2;
     egysegy:=Round((jay-bfy)/max);
     For i:=0 To elemsz-1 Do
         Begin
              If t[i]>max-10
               Then
                 Begin
                      Bar(bfx+((i)*egysegx),jay-((max-10)*egysegy),bfx+((i+1)*egysegx),jay);
                 End
               Else
                 Begin
                      Bar(bfx+((i)*egysegx),jay-(t[i]*egysegy),bfx+((i+1)*egysegx),jay);
                 End;
         End;
		 SetColor(2);
     If tengely
        Then
            Begin
               {tengelyek}
                 Line(bfx,bfy,bfx,jay);
                 Line(bfx,jay,jax,jay);
               {tengely nyilak}
                 Line(bfx,bfy,bfx-4,bfy+4);
                 Line(bfx,bfy,bfx+4,bfy+4);
                 Line(jax,jay,jax-4,jay-4);
                 Line(jax,jay,jax-4,jay+4);
               {tengely nv}
                 SetTextStyle(2,0,4);
                 OutTextXY(bfx+10,bfy,'Hnyszhor volt'); {Y}
                 OutTextXY(jax-40,jay+18,'Darazsak szma az 1. dobozban'); {X}
               {X tengelyre szmozs}
                 SetTextStyle(2,1,2);
                 For i:=0 To elemsz Do
                     Begin
                          Str(i,sv);
                          OutTextxy(bfx+(i*egysegx)+(egysegx div 3),jay+10,sv);
                     End;
                 SetTextStyle(0,0,0);
               {egysgek az X tengelyre}
                 For i:=0 To elemsz Do
                     Begin
                          Line(bfx+(i*egysegx),jay-4,bfx+(i*egysegx),jay+4);
                     End;
               {egysgek az Y tengelyre}
                 For i:=0 To max-10 Do
                     Begin
                          Line(bfx-4,jay-(i*egysegy),bfx+4,jay-(i*egysegy));
                     End;
            End;
     If felirat
        Then
            Begin
                 For i:=0 To Elemsz Do
                     Begin
                          Str(t[i],sv);
                          If t[i]>max-10
                            Then
                              Begin
                                   SetTextStyle(2,1,2);
                                   SetTextJustify(2,1);
                                   OutTextxy(bfx+(i*egysegx)+(egysegx div 2),g_t+10,sv);
                              End
                            Else
                              Begin
                                   SetTextStyle(2,0,2);
                                   SetTextJustify(1,2);
                                   OutTextxy(bfx+(i*egysegx)+(egysegx div 2),jay-(t[i]*egysegy)-15,sv);
                              End;


                     End;
                 SetTextStyle(0,0,0);
            End;
    SetTextJustify(0,0);
End;

Procedure parameter(bfx,bfy,jax,jay:integer);
var sv:char;
    p:pointer;
    svs:integer;
    n1:string;
Begin
     setfillstyle(solidfill,black);
     bar(bfx,bfy,jax,jay);
     setcolor(yellow);
     rectangle(bfx,bfy,jax,jay);
     str(n,n1);
     n1:='A darazsak szma:'+n1;
     outtextxy(bfx-233,bfy+13,n1);
     str(a,n1);
     n1:='Az 1.-ben a m. akt. szma:'+n1;
     outtextxy(bfx-233,bfy+23,n1);
     svs:=n-a;
     str(svs,n1);
     n1:='Az 2.-ben a m. akt. szma:'+n1;
     outtextxy(bfx-233,bfy+33,n1);
     setfillstyle(solidfill,blue);
End;

Procedure normal;
Begin
     setcolor(yellow);
     outtextxy(55,450,'Norml');
     setcolor(lightred);
     outtextxy(55,450,'N');
End;

Procedure csendes;
Begin
     setcolor(yellow);
     outtextxy(120,450,'Csendes');
     setcolor(lightred);
     outtextxy(120,450,'C');
End;
Procedure grafikonbeki;
Begin
     setcolor(yellow);
     outtextxy(190,450,'Grafikon be/ki');
     setcolor(lightred);
     outtextxy(190,450,'G');
End;
Procedure Lepesenkent;
Begin
     setcolor(yellow);
     outtextxy(315,450,'Lpsenknt');
     setcolor(lightred);
     outtextxy(315,450,'L');
End;
Procedure parameterek;
Begin
     setcolor(yellow);
     outtextxy(415,450,'Paramter');
     setcolor(lightred);
     outtextxy(415,450,'P');
End;
Procedure kilep;
Begin
     setcolor(yellow);
     outtextxy(500,450,'Kilp');
     setcolor(lightred);
     outtextxy(500,450,'K');
End;
Procedure help;
Begin
     setcolor(yellow);
     outtextxy(555,450,'Help');
     setcolor(lightred);
     outtextxy(555,450,'H');
End;


Procedure menuki(bfx,bfy,jax,jay:integer);
Begin
     bar(bfx,bfy,jax,jay);
     setfillstyle(solidfill,green);
     bar(bfx+3,bfy+5,bfx+55,jay-10);
     normal;
     csendes;
     grafikonbeki;
     lepesenkent;
     parameterek;
     kilep;
     help;
     hol:=1;
End;

Procedure szimlepes;
var i:integer;
Begin
	Randomize;
        i:=0;
	i:=random(n);
        If d[i]=1
		then
    	            Begin
		         d[i]:=2;
                         a:=a-1;
                         t[a]:=t[a]+1;
                    End
                Else
    	            Begin
      	                 d[i]:=1;
                         a:=a+1;
                         t[a]:=t[a]+1;
                    End;
End;

Procedure szimido(x,y:integer);
var sv:string;
Begin
     setfillstyle(1,black);
     bar(x,y-10,x+100,y);
     szi:=szi+1;
     str(szi,sv);
     sv:='Szim id:'+sv;
     setcolor(lightred);
     outtextxy(x,y,sv);
     Delay(300);
End;

Procedure kilep1(var seged:char);
Begin
     seged:=' ';
     Repeat
        setfillstyle(solidfill,blue);
        bar(50,430,600,470);
        setcolor(yellow);
        outtextxy(205,450,'Kilps   Mgsem    Ellrl');
        setcolor(lightred);
        outtextxy(205,450,'K');
        setcolor(lightred);
        outtextxy(285,450,'M');
        setcolor(lightred);
        outtextxy(365,450,'E');
        seged:=Readkey;
     Until (seged='k') or (seged='K') or (seged='m') or (seged='M') or (seged='E') or (seged='e');
     If (seged='k') or (seged='K')
        Then
            kilepo:='v'
        Else
            menuki(50,430,600,470);
End;

Procedure menu(bfx,bfy,jax,jay:integer;var hol:integer);
var c:char;
Begin
     Repeat
           s:=readkey;
      	If s=#0 then  begin
                  c:=readkey;
                       case c of
                            #75: begin
                                      case hol of
                                         2:
                                           Begin
                                                setfillstyle(solidfill,green);
                                                bar(bfx,bfy,bfx+55,jay-5);
                                                normal;
                                                setfillstyle(solidfill,blue);
                                                bar(bfx+60,bfy,bfx+125,jay-5);
                                                csendes;
                                                hol:=1;
                                                s:='v';
                                           End;
                                         1:
                                             Begin
                                                  setfillstyle(solidfill,blue);
                                                  bar(bfx,bfy,bfx+55,jay);
                                                  normal;
                                                  setfillstyle(solidfill,green);
                                                  bar(bfx+495,bfy,bfx+540,jay-5);
                                                  help;
                                                  hol:=7;
                                                  s:='v';
                                             End;
                                         7:
                                             Begin
                                                  setfillstyle(solidfill,blue);
                                                  bar(bfx+495,bfy,bfx+540,jay-5);
                                                  help;
                                                  setfillstyle(solidfill,green);
                                                  bar(bfx+443,bfy,bfx+490,jay-5);
                                                  kilep;
                                                  hol:=6;
                                                  s:='v';
                                             End;
                                         6:
                                             Begin
                                                  setfillstyle(solidfill,blue);
                                                  bar(bfx+443,bfy,bfx+490,jay-5);
                                                  kilep;
                                                  setfillstyle(solidfill,green);
                                                  bar(bfx+360,bfy,bfx+435,jay-5);
                                                  parameterek;
                                                  hol:=5;
                                                  s:='v';
                                             End;
                                         5:
                                             Begin
                                                  setfillstyle(solidfill,blue);
                                                  bar(bfx+360,bfy,bfx+435,jay-5);
                                                  parameterek;
                                                  setfillstyle(solidfill,green);
                                                  bar(bfx+260,bfy,bfx+350,jay-5);
                                                  lepesenkent;
                                                  hol:=4;
                                                  s:='v';
                                             End;
                                         4:
                                             Begin
                                                  setfillstyle(solidfill,blue);
                                                  bar(bfx+260,bfy,bfx+350,jay-5);
                                                  lepesenkent;
                                                  setfillstyle(solidfill,green);
                                                  bar(bfx+130,bfy,bfx+255,jay-5);
                                                  grafikonbeki;
                                                  hol:=3;
                                                  s:='v';
                                             End;
                                         3:
                                             Begin
                                                  setfillstyle(solidfill,blue);
                                                  bar(bfx+130,bfy,bfx+255,jay-5);
                                                  grafikonbeki;
                                                  setfillstyle(solidfill,green);
                                                  bar(bfx+60,bfy,bfx+125,jay-5);
                                                  csendes;
                                                  hol:=2;
                                                  s:='v';
                                             End;
                                         End;
                                   end;
                            #77: begin
                                      case hol of
                                         7:
                                           Begin
                                                setfillstyle(solidfill,green);
                                                bar(bfx,bfy,bfx+55,jay-5);
                                                normal;
                                                setfillstyle(solidfill,blue);
                                                bar(bfx+495,bfy,bfx+540,jay-5);
                                                help;
                                                hol:=1;
                                                s:='v';
                                           End;
                                         1:
                                             Begin
                                                  setfillstyle(solidfill,blue);
                                                  bar(bfx,bfy,bfx+55,jay);
                                                  normal;
                                                  setfillstyle(solidfill,green);
                                                  bar(bfx+60,bfy,bfx+125,jay-5);
                                                  csendes;
                                                  hol:=2;
                                                  s:='v';
                                             End;
                                         2:
                                             Begin
                                                  setfillstyle(solidfill,blue);
                                                  bar(bfx+60,bfy,bfx+125,jay-5);
                                                  csendes;
                                                  setfillstyle(solidfill,green);
                                                  bar(bfx+130,bfy,bfx+255,jay-5);
                                                  grafikonbeki;
                                                  hol:=3;
                                                  s:='v';
                                             End;
                                         3:
                                             Begin
                                                  setfillstyle(solidfill,blue);
                                                  bar(bfx+130,bfy,bfx+255,jay-5);
                                                  grafikonbeki;
                                                  setfillstyle(solidfill,green);
                                                  bar(bfx+260,bfy,bfx+350,jay-5);
                                                  lepesenkent;
                                                  hol:=4;
                                                  s:='v';
                                             End;
                                         4:
                                             Begin
                                                  setfillstyle(solidfill,blue);
                                                  bar(bfx+260,bfy,bfx+350,jay-5);
                                                  lepesenkent;
                                                  setfillstyle(solidfill,green);
                                                  bar(bfx+360,bfy,bfx+435,jay-5);
                                                  parameterek;
                                                  hol:=5;
                                                  s:='v';
                                             End;
                                         5:
                                             Begin
                                                  setfillstyle(solidfill,blue);
                                                  bar(bfx+360,bfy,bfx+435,jay-5);
                                                  parameterek;
                                                  setfillstyle(solidfill,green);
                                                  bar(bfx+443,bfy,bfx+490,jay-5);
                                                  kilep;
                                                  hol:=6;
                                                  s:='v';
                                             End;
                                         6:
                                             Begin
                                                  setfillstyle(solidfill,blue);
                                                  bar(bfx+443,bfy,bfx+490,jay-5);
                                                  kilep;
                                                  setfillstyle(solidfill,green);
                                                  bar(bfx+495,bfy,bfx+540,jay-5);
                                                  help;
                                                  hol:=7;
                                                  s:='v';
                                             End;
                                         End;
                                   end;
                       end;
        End;
     If s=#13
        Then
            Begin
                 case hol of
                      1: Begin
                              s:='v';
                         End;
                      2: Begin
                              s:='v';
                         End;
                      3: Begin
                              s:='v';
                         End;
                      4: Begin
                              s:='v';
                         End;
                      5: Begin
                              {parameterno;}
                              s:='v';
                         End;
                      6: Begin
                              kilep1(seged);
                              s:='v';
                         End;
                      7: Begin
                              {help1;}
                              s:='v';
                         End;
                 End;
            End;
    until (s='v') or (s='V');
  End;



Begin
     clrscr;
     feltolt;
     Grafikusra;
     szimnev(50,10,'Elemi difzis gzmodell');
     szimter(50,70,400,250);
     grafikon(60,260,440,375,t,n,true,false,white);
     {tengely(50,250,400,400);}
     parameter(638,70,400,250);
     menuki(50,430,600,470);
     repeat
           if keypressed then
                             begin
                                  menu(53,435,655,465,hol);
                             end;
           szimido(450,50);
           szimlepes;
           szimter(50,70,400,250);
           parameter(638,70,400,250);
           grafikon(60,260,440,375,t,n,true,false,white);
     until (kilepo='V') or (kilepo='v');
     Szovegesre;
End.