Unit szim_ker;

Interface
Uses newdelay,Crt,Graph;

Const maxn=100;                           {max adat szm}

Type Pont =  Record x,y : Integer;
             End;
     Ablakt = Record bf,ja : Pont;
             End;
     scr = Array[1..6] of Ablakt;
     Adat  = Array[1..maxn] of Real;      {Adatok}
     MenuT  = Array[1..6] of String;
Var
    Ablak:scr;                       {A kperny ngy ablaka}
    Cim,s : String;                  {A kperny cmsora}
    lepes:integer;                   {hanyadik szimulacios lepes}
    Menu : MenuT;
    m:byte;                          {akttiv menu szama, szovegszin}
    vege : boolean;                  {ha igazza valik, kilepes a pr-bol}
    indit:boolean;                   {ha igaz, vege a menukezelesnek, indul a szimulacio}
    megszakit:boolean;

procedure kilep;
procedure normal;

const  opciok:array[1..6]of procedure=(normal,kilep,kilep,kilep,kilep,kilep);

FUNCTION  INITGR:BOOLEAN; {Kperny inicializls}
PROCEDURE INITABLAK;
PROCEDURE INITMENU;
PROCEDURE MENUKEZEL;
PROCEDURE SZAMLALO;


IMPLEMENTATION

FUNCTION INITGR:BOOLEAN;
  var
    gd, gm : integer;
    path:string;

  begin
    path:='d:\turbo_p\bgi';
    DetectGraph(gd, gm);
    InitGraph(gd, gm, path);
    if (GraphResult <> grok)
        then repeat
               write('Add meg a bgi fajl utvonalat (kilepes "Enter"-rel): ');
               readln(path);
               if path<>'' then  begin
                                 DetectGraph(gd, gm);
                                 InitGraph(gd, gm, path);
                                 end
                           else vege:=true;
             until (vege) or (graphresult=grok);
    initgr:=(graphresult=grok);
  end;

PROCEDURE INITABLAK;

begin

    cim:='Szimulacio cime';
    ablak[1].bf.x:=5;
    ablak[1].bf.y:=5;
    ablak[1].ja.x:=400;
    ablak[1].ja.y:=40;

    ablak[2].bf.x:=405;
    ablak[2].bf.y:=5;
    ablak[2].ja.x:=635;
    ablak[2].ja.y:=40;

    ablak[3].bf.x:=5;
    ablak[3].bf.y:=45;
    ablak[3].ja.x:=400;
    ablak[3].ja.y:=240;

    ablak[4].bf.x:=405;
    ablak[4].bf.y:=45;
    ablak[4].ja.x:=635;
    ablak[4].ja.y:=240;

    ablak[5].bf.x:=5;
    ablak[5].bf.y:=245;
    ablak[5].ja.x:=635;
    ablak[5].ja.y:=440;

    ablak[6].bf.x:=5;
    ablak[6].bf.y:=445;
    ablak[6].ja.x:=635;
    ablak[6].ja.y:=475;

    rectangle(0,0,639,479);

    rectangle(ablak[1].bf.x,ablak[1].bf.y,ablak[1].ja.x,ablak[1].ja.y);
    rectangle(ablak[2].bf.x,ablak[2].bf.y,ablak[2].ja.x,ablak[2].ja.y);
    rectangle(ablak[3].bf.x,ablak[3].bf.y,ablak[3].ja.x,ablak[3].ja.y);
    rectangle(ablak[4].bf.x,ablak[4].bf.y,ablak[4].ja.x,ablak[4].ja.y);
    rectangle(ablak[5].bf.x,ablak[5].bf.y,ablak[5].ja.x,ablak[5].ja.y);
    settextjustify(1,1);
    outtextxy((ablak[1].bf.x+ablak[1].ja.x)div 2,(ablak[1].bf.y+ablak[1].ja.y)div 2,cim);
    settextjustify(2,1);
    outtextxy((ablak[2].bf.x+ablak[2].ja.x)div 2,(ablak[2].bf.y+ablak[2].ja.y)div 2,'lpsszm: ');
    settextjustify(1,1);
end;

PROCEDURE AKTIVMENU(m,c:integer);
begin
    settextjustify(1,1);
    setviewport(ablak[6].bf.x,ablak[6].bf.y,ablak[6].ja.x,ablak[6].ja.y,true);
    setfillstyle(1,c);
    bar((m-1)*(-ablak[6].bf.x+ablak[6].ja.x) div 6,0,m*(-ablak[6].bf.x+ablak[6].ja.x) div 6,(-ablak[6].bf.y+ablak[6].ja.y));
    setcolor(abs(15-c));
    outtextxy((-ablak[6].bf.x+ablak[6].ja.x)*(2*m-1)div 12,(-ablak[6].bf.y+ablak[6].ja.y)div 2,menu[m]);

end;

PROCEDURE INITMENU;
begin
     menu[1]:='Norml';
     menu[2]:='Csendes';
     menu[3]:='Lpsben';
     menu[4]:='Paramterek';
     menu[5]:='Segtsg';
     menu[6]:='Kilp';
     for m:=1 to 6 do
       begin
         setviewport(ablak[6].bf.x,ablak[6].bf.y,ablak[6].ja.x,ablak[6].ja.y,true);
         outtextxy((-ablak[6].bf.x+ablak[6].ja.x)*(2*m-1)div 12,(-ablak[6].bf.y+ablak[6].ja.y)div 2,menu[m]);
       end;
     m:=1;
     aktivmenu(m,15);
end;

{$f+}
PROCEDURE KILEP;
begin
    vege:=true;
end;

PROCEDURE NORMAL;
begin
    indit:=true;
end;
{$f-}

PROCEDURE MENUKEZEL;
var ch:char;
begin
  indit:=false;
  repeat
    ch:=readkey;
    if ch=#0 then ch:=readkey;
    case ch of
      #77:begin
              aktivmenu(m,0);
              m:=(m mod 6)+1;
              aktivmenu(m,15)
          end;
      #75:begin
              aktivmenu(m,0);
              m:=(m-1)mod 6;
              if m=0 then m:=6;
              aktivmenu(m,15);
          end;
      #13:begin
              opciok[m];
          end;
    end;
  until indit or vege;
end;

PROCEDURE SZAMLALO;
begin
     lepes:=lepes+1;
     settextjustify(0,1);
     setviewport(ablak[2].bf.x,ablak[2].bf.y,ablak[2].ja.x,ablak[2].ja.y,true);
     str(lepes,s);
     setcolor(15);
     outtextxy((-ablak[2].bf.x+ablak[2].ja.x)div 2,(-ablak[2].bf.y+ablak[2].ja.y)div 2,s);
     delay(100);
     setcolor(0);
     outtextxy((-ablak[2].bf.x+ablak[2].ja.x)div 2,(-ablak[2].bf.y+ablak[2].ja.y)div 2,s);
end;

BEGIN
END.